<template>
  <div class="div">
    <v-tabs
      v-model="tabs"
      align-with-title
    >
      <v-tab href="#Контакты">
        Контакты
      </v-tab>
      <v-tab href="#Сделки">
        Сделки
      </v-tab>
      <v-tab href="#Регионы">
        Регионы
      </v-tab>
      <v-tabs-slider color="pink"></v-tabs-slider>
    </v-tabs>
    <div class="fields-wrap mt-4">
      <v-data-table
        :headers="headers"
        :items="desserts"
        sort-by="createdAt"
        class="elevation-1"
        :loading="loading"
        loading-text="Загрузка... Пожалуйста ждите"
      >
        <template v-slot:item.type="{ item }">
          <v-chip
            dark
          >
            {{ item.type }}
          </v-chip>
        </template>
        <template v-slot:top>
          <v-toolbar
            flat
          >
            <v-toolbar-title>{{tabs}}</v-toolbar-title>
            <v-divider
              class="mx-4"
              inset
              vertical
            ></v-divider>
            <v-spacer></v-spacer>
            <v-dialog
              v-model="dialog"
              max-width="500px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  color="primary"
                  dark
                  class="mb-2"
                  v-bind="attrs"
                  v-on="on"
                >
                  Добавить поле
                </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="text-h5">{{ formTitle }}</span>
                </v-card-title>

                <v-card-text>
                  <v-container>
                    <v-text-field
                      v-model="editedItem.name"
                      label="Название поля"
                      dense
                      solo
                    ></v-text-field>
                    <v-select
                      :items="['Текст', 'Цифровое', 'Текстовая область', 'Список', 'Чекбокс']"
                      label="Тип поля"
                      v-model="editedItem.type"
                      dense
                      solo
                    ></v-select>
                    <v-textarea v-if="editedItem.type === 'Список'" v-model="selectOptions" label="Элементы списка, через enter"/>
                    <v-sheet class="pa-2">
                      <p>Видимость</p>
                      <v-switch
                        v-model="editedItem.visible"
                        inset
                        :label="`${editedItem.visible ? 'Виден': 'Скрыт'}`"
                      ></v-switch>
                    </v-sheet>
                  </v-container>
                </v-card-text>

                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn
                    color="blue darken-1"
                    text
                    @click="close"
                  >
                    Закрыть
                  </v-btn>
                  <v-btn
                    color="blue darken-1"
                    text
                    @click="save"
                    :loading="loadingEditButton"
                  >
                    Сохранить
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
            <v-dialog v-model="dialogDelete" max-width="500px">
              <v-card>
                <v-card-title class="text-h5 justify-center">Удалить эту воронку?</v-card-title>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="blue darken-1" text @click="closeDelete">Отмена</v-btn>
                  <v-btn :loading="loadingDeleteButton" color="red darken-1" text @click="deleteItemConfirm">Удалить</v-btn>
                  <v-spacer></v-spacer>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar>
        </template>
        <template v-slot:item.visible="{ item }">
          {{item ? 'Виден' : 'Скрыт'}}
        </template>
        <template v-slot:item.actions="{ item }">
          <v-icon
            small
            class="mr-2"
            @click="editItem(item)"
          >
            mdi-pencil
          </v-icon>
          <v-icon
            small
            @click="deleteItem(item)"
          >
            mdi-delete
          </v-icon>
        </template>
        <template v-slot:no-data>
          <v-btn
            color="primary"
            @click="initialize"
          >
            Перезагрузить
          </v-btn>
        </template>
      </v-data-table>
    </div>
  </div>
</template>

<script>
import api from '@/API/api'

export default {
  name: 'FieldsSettings',
  data: () => ({
    fab: false,
    hidden: false,
    tabs: null,
    dialog: false,
    dialogDelete: false,
    loading: false,
    loadingEditButton: false,
    loadingDeleteButton: false,
    color: "",
    name: "",
    headers: [
      {
        text: 'Название',
        align: 'start',
        sortable: false,
        value: 'name',
      },
      { text: 'Тип', value: 'type' },
      { text: 'Видимость', value: 'visible' },
      { text: 'Действия', value: 'actions' },
    ],
    desserts: [],
    editedIndex: -1,
    selectOptions: '',
    editedItem: {
      name: "",
      type: "text",
      visible: true,
      values: []
    },
    defaultItem: {
      name: "",
      type: "text",
      visible: true,
      values: []
    },
    fields: []
  }),
  watch: {
    dialog (val) {
      val || this.close()
    },
    dialogDelete (val) {
      val || this.closeDelete()
    },
    tabs (val) {
      this.changeCategory(val)
    }
  },
  created () {
    this.initialize()
  },
  computed: {
    activeFab () {
      switch (this.tabs) {
        case 'Контакты': return { color: 'success', icon: 'mdi-share-variant' }
        case 'Сделки': return { color: 'red', icon: 'mdi-pencil' }
        case 'Регионы': return { color: 'green', icon: 'mdi-chevron-up' }
        default: return {}
      }
    },
    formTitle () {
      return this.editedIndex === -1 ? 'Новое поле' : 'Редактирование поля'
    },
  },
  methods: {
    async initialize () {
      this.loading = true
      await api.getFields()
        .then(res => {
          this.fields = res.data.fields
          this.changeCategory(this.tabs)
          this.loading = false
        })
        .catch(() => {
          this.loading = false
          this.desserts = []
          this.fields = []
        })
    },
    changeCategory (el) {
      this.desserts = this.fields.filter(elem => {
        return elem.category === el
      })
    },

    editItem (item) {
      this.selectOptions = item.values.join('\n')
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem (item) {
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    async deleteItemConfirm () {
      this.loadingDeleteButton = true
      this.desserts.splice(this.editedIndex, 1)
      await api.deleteFields({_id: this.editedItem._id})
        .then(res => {
          res.data.status && (this.loadingDeleteButton = false)
          this.closeDelete()
        })
    },

    close () {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete () {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    async save () {
      this.loadingEditButton = true
      if (this.editedIndex > -1) {
        const item = this.desserts[this.editedIndex]
        item.type === 'Список' && (item.values = this.selectOptions.split('\n'))
        this.editedItem.type === 'Список' && (this.editedItem.values = this.selectOptions.split('\n'))
        Object.assign(item, this.editedItem)
        await api.changeFields({
          _id: this.editedItem._id,
          name: this.editedItem.name,
          type: this.editedItem.type,
          visible: this.editedItem.visible,
          values: this.editedItem.type === 'Список' && this.selectOptions.split('\n') || this.editedItem.values,
          category: this.tabs
        })
          .then(res => res.data.status && (this.loadingEditButton = false))
      } else {
        this.desserts.push(this.editedItem)
        await api.addFields({
          name: this.editedItem.name,
          type: this.editedItem.type,
          visible: this.editedItem.visible,
          values: this.editedItem.type === 'Список' && this.selectOptions.split('\n') || this.editedItem.values,
          category: this.tabs
        })
          .then(res => res.data.status && this.initialize())
        this.loadingEditButton = false
      }
      this.close()
    },
  }
}
</script>

<style scoped>

</style>
